require 'rubygems'
require 'selenium-webdriver'

require_relative  "../module/DriverUtility"

class EntryForm

  include DriverUtility

  def initialize(driver)
    @driver = driver
  end

  def getScreenContent()
    return getElement(:css, "form[name='entryForm']").text()
  end

  def getFormContent()
    return getElement(:css, "form[name='form']").text()
  end

  def isInputChecked(selector)
    return getElement(:css, selector).attribute("checked") ? true : false
  end

  def isSaveButtonVisible()
    return is_element_present(:css, "button[ng-click='save()']")
  end

  def isDeleteButtonVisible()
    return is_element_present(:css, "button[ng-click='delete()']")
  end

  def isCancelButtonVisible()
    return is_element_present(:css, "button[ng-click='cancel()']")
  end

  def isBackButtonVisible()
    return is_element_present(:css, "button[ng-click='goBack()']") ? true : false
  end

  def isBackButtonOnMyStoryScreensVisible()
    return is_element_present(:css, "button[title='Navigation Screen']") ? true : false
  end

  def getBackButtonAltText()
    return getElement(:css, "button[ng-click='goBack()']").attribute("title")
  end

  def clickBackButton()
    click(:css, 'button[ng-click="goBack()"]')
    sleep 1
  end

  def clickBackButtonOnMyStoryScreens()
    click(:css, "button[title='Navigation Screen']")
    sleep 1
  end

  def clickSaveButton()
    click(:css, 'button[ng-click="save()"]')
    sleep 2.5
  end

  def clickDeleteButton
    click(:css, 'button[ng-click="delete()"]')
  end

  def clickCancelButton()
    click(:css, 'button[ng-click="cancel()"]')
    sleep 0.5
  end

  def clickAddEntryButton()
    click(:css, 'button[ng-click="getDetails()"]')
    sleep 1
  end

end