require 'rubygems'
require 'selenium-webdriver'
require 'jquery'

require_relative  "../module/DriverUtility"

class Date_Picker
  include DriverUtility


  def initialize(driver)
    @driver = driver
  end

  def setMonth(monthNum)
    click(:css, "button[type='month'][data-value='" + monthNum.to_s + "']")
    sleep 2
  end

  def setDay(dayNum)
    click(:css, "button[type='day'][data-value='" + dayNum.to_s + "']")
    sleep 2
  end

  def setYear(yearNum)
    click(:css, "button[type='year'][data-value='" + yearNum.to_s + "']")
    sleep 2
  end

  def setDateFromGUI(month, day, year)
    sleep 1
    setYear(year)
    sleep 1
    setMonth(month)
    sleep 1
    setDay(day)
    sleep 1

    clickSet()
    sleep 1
  end

  def setMonthYearFromGUI(month, year)
    setYear(year)
    sleep 1.5
    setMonth(month)
    sleep 1.5
    clickSet()
    sleep 1.5
  end



  def getSetButtonText()
    puts ("[GetSetButton Text ] " + getTextForElement(:css, "#set-btn [aria-hidden]"))
    return getTextForElement(:css, "#set-btn [aria-hidden]")
  end

  def clickStartDateCalendarBtn()
    click(:css, "date-control[field-id='startDate'] .input-group-btn button")
  end

  def clickEndDateCalendarBtn()
    click(:css, "date-control[field-id='endDate'] .input-group-btn button")
  end

  def clickSet()
    click(:css, "#set-btn")
  end

  def clickCloseBtn()
    click(:css, "#date-picker a[ng-click='close($event)']")
  end

  def getSelectedMonth()
    return getTextForElement(:css, "button[type='month'].selected")
  end

  def getSelectedDay()
    return getTextForElement(:css, "button[type='day'].selected")
  end

  def getSelectedYear()
    return getTextForElement(:css, "button[type='year'].selected")
  end

  def convertMonthStrToMonthNumber (monthStr)
    months = ["JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"]
    return months.index(monthStr) + 1
  end

  def areMonthsAfterThisDisabled(monthStr)
    afterThisMonthNum = convertMonthStrToMonthNumber(monthStr) + 1

    monthsValuesDisabled = true
    monthRowCount = getElements(:css, '.month ul li').length

    for i in afterThisMonthNum...monthRowCount
      element = getElement(:css, ".month ul li:nth-of-type(" + i.to_s + ") button")

      if element.attribute("disabled") !=  "true" then
        monthsValuesDisabled = false
        puts "Month after this month was not disabled: " + afterThisMonthNum.to_s

        break
      end
    end

    return monthsValuesDisabled
  end

  def areDaysAfterThisDisabled(dayStr)

    afterThisDayNum = dayStr.to_i + 2
    dayValuesDisabled = true
    dayRowCount = getElements(:css, '.day ul li').length
    for i in afterThisDayNum...dayRowCount
      element = getElement(:css, ".day ul li:nth-of-type(" + i.to_s + ") button")
      if element.attribute("disabled") !=  "true" then
        dayValuesDisabled = false
        puts "Days after this day was not disabled: " + afterThisDayNum.to_s

        break
      end

    end
    return dayValuesDisabled

  end

  def verifyTheYearIsTheLastInList(yearStr)
    displayedYearsCount = getElements(:css, '.year ul li').length

    verifyTheYearIsTheLastInList = true
    for i in 1..displayedYearsCount
      whatYear = getTextForElement(:css, ".year ul li:nth-of-type(" + i.to_s + ") button")

      if whatYear.to_i > yearStr.to_i
        verifyTheYearIsTheLastInList = false
        break
      end

    end

    return verifyTheYearIsTheLastInList
  end

  def verifyAvailableDatesWithinNYears(numberOfYears)
    startDate = getDateNthYeasFromNow(numberOfYears, "%m/%d/%Y")
  end


end