require 'rubygems'
require 'selenium-webdriver'

require_relative "../module/DriverUtility"


class Images_Documents
  include DriverUtility

  CATEGORY = "select[name='category']"
  FILTERCATEGORY = "select[name='filterCategory']"
  TYPE = "select[name='type']"
  DATE = "input[name='date']"
  STARTDATE = "input[name='startDate']"
  ENDDATE = "input[name='endDate']"
  INFO_MODAL ="span[id='fileUploadInfo']"
  ATTACH_FILE = "button[name='addAttachment']"
  NOTES = "textarea[name='Notes']"
  X_DELETE = "button[ng-click='deleteAttachment()']"



  def initialize(driver)
    @driver = driver
  end

  def clickInfoModal()
    click(:css, INFO_MODAL)
  end

  def deleteAttachedFile()
    click(:css, X_DELETE)
  end

  def isFilterCollapsed
    element = @driver.find_element(:css, "li.filter-toggle button")
    return (element.attribute('title') == 'Expand filter options')
  end

  def isTheFilterButtonVisible()
    return @driver.find_element(:css, "button[ng-click='filter()']").displayed?
  end

  def isTheResetButtonVisible()
    return @driver.find_element(:css, "button[ng-click='reset()']").displayed?
  end

  def clickFilter
    click(:css, 'button[ng-click="filter()"]')
    sleep 2
  end

  def clickReset
    click(:css, 'button[ng-click="reset()"]')
    sleep 2
  end

  def showOrHideFilter()
    click(:css, ".filter-toggle i.pull-left")
    sleep 2
  end

  def selectType(type)
    click(:css, "select[name='type'] option[value='" + type + "']")
  end

  def selectCategory(category)
    click(:css, "select[name='filterCategory'] option[value='" + category + "']")
  end


end