require 'rubygems'
require 'selenium-webdriver'

require_relative  "../module/DriverUtility"

class Main
  include DriverUtility

  TITLE = ".main-title[aria-hidden]"
  NAV_MENU = "nav-menu-toggle-btn"
  USER_MENU = "user-menu-toggle-btn"
    
  def initialize(driver)
     @driver = driver
     #@base_url = baseUrl
     #sleep 1.5
  end

  def getFooterText()
    return getTextForElement(:css, "span[ng-if='userName']")
  end
  
  def clickNavMenu
    click(:id, NAV_MENU)
  end
  
  def isNavMenuVisible
    return getElement(:id, NAV_MENU).displayed?
  end
  
  def clickUserMenu
    click(:id, USER_MENU)
  end
  
  def getTitle()
    return getTextForElement(:css, TITLE)
  end
  
end