require 'rubygems'
require 'selenium-webdriver'

require_relative '../module/DriverUtility'

class PreventiveServices

  include DriverUtility

  def initialize(driver)
    @driver = driver
  end

  def getHealthFinderText
    return getTextForElement(:css, "div[ui-view='primary'] span.placeholder-message")
  end

  def getHealthFinderLinkText
    return getTextForElement(:css, "div[ui-view='primary'] span.placeholder-message > a")
  end

  def clickLink
    return click(:css, "a[ng-click='goToHealthFinder()']")
  end

  def isUrlCorrect?
    urlLink = @driver.current_url
    return urlLink.include?("http://healthfinder.gov/")
  end

  def isUrlGenderMale?
    urlLink = @driver.current_url
    return urlLink.include?("gender=male")
  end

  def isUrlGenderFemale?
    urlLink = @driver.current_url
    return urlLink.include?("gender=female")
  end

  def isUrlPregnantFalse?
    urlLink = @driver.current_url
    return urlLink.include?("pregnant=0")
  end

  def isUrlPregnantTrue?
    urlLink = @driver.current_url
    return urlLink.include?("pregnant=1")
  end
end