require 'rubygems'
require 'selenium-webdriver'
require 'jquery'

require_relative  "../module/DriverUtility"

class Time_Picker
  include DriverUtility


  def initialize(driver)
    @driver = driver
  end

  def clickTimePickerButton()
    click(:css, "i.icon-time")
  end

  def convertMinuteToRowID(minStr)
    minRowCount = getElements(:css, 'b.minute ul li').length

    minRowCount.downto(1) do |rowID|
      mintueStr = getTextForElement(:css, "b.minute ul li:nth-of-type(" + rowID.to_s + ") button")
      if mintueStr == minStr then
        #puts "[convertMonthToRowID] RowId " + rowID.to_s
        return rowID
      end
    end
  end

  def setHour(hourNum)
    #b.hour > ul > li:nth-child(3) > button
    click(:css, "b.hour [data-value='" + hourNum.to_s + "']")
    sleep 2.0
  end

  def setMinute(minStr)
    # minuteNum = convertMinuteToRowID(minStr)
    #b.minute > ul > li:nth-child(3) > button
    click(:css, "b.minute [data-value='" + minStr.to_i.to_s + "']")
    sleep 1.5
  end

  def setAMPM(whenStr)
    #b.period > ul > li:nth-child(2) > button
    if (whenStr == "AM") then
      lis = 1
    elsif (whenStr == "PM") then
      lis = 2
    end
    click(:css, "b.period ul li:nth-of-type(" + lis.to_s + ") button")
    sleep 0.5
  end

  def areMinutesIn5MinIntervals()
    intervalSetCorrectly = true
    minuteRowCount = getElements(:css, 'b.minute ul li').length

    for i in 1..minuteRowCount
      displayedText = getTextForElement(:css, 'b.minute ul li:nth-of-type(' + i.to_s + ') button')
      #puts "displayedText= "+ displayedText
      #puts "displayedText.reverse[0,1].reverse = " + displayedText.reverse[0,1].reverse
      if (displayedText.reverse[0,1].reverse != '0') and (displayedText.reverse[0,1].reverse != '5') then
        intervalSetCorrectly = false
        break
      end

    end

    return intervalSetCorrectly

  end

  def clickSet()
    click(:id, "set-btn")
  end

  def clickCloseBtn()
    click(:css, "#time-picker a[ng-click='close($event)']")
  end

  def getSetButtonText()
    #puts ("[GetSetButton Text ] " + getTextForElement(:css, "#set-btn span:nth-of-type(2)"))
    return getTextForElement(:css, "#set-btn span:nth-of-type(2)")
  end

  def getSelectedTimePeriod()
    periodRowCount = getElements(:css, '#time-picker div:nth-of-type(1) b.period ul li').length

    for i in 1..periodRowCount
      element = getElement(:css,  "#time-picker div:nth-of-type(1) b.period ul li:nth-of-type(" + i.to_s + ") button")
      className = element.attribute("class")

      if className.include?('selected') == true then
        return getTextForElement(:css,  "#time-picker div:nth-of-type(1) b.period ul li:nth-of-type(" + i.to_s + ") button")
        break
      end

    end

  end

  def getSelectedMinute()
    minuteRowCount = getElements(:css, '#time-picker div:nth-of-type(1) b.minute ul li').length

    for i in 1..minuteRowCount
      element = getElement(:css, "#time-picker div:nth-of-type(1) b.minute ul li:nth-of-type(" + i.to_s + ") button")
      className = element.attribute("class")

      if className.include?('selected') == true then
        return getTextForElement(:css, "#time-picker div:nth-of-type(1) b.minute ul li:nth-of-type(" + i.to_s + ") button")
        break
      end

    end
  end

  def getSelectedHour()
    hourRowCount = getElements(:css, '#time-picker div:nth-of-type(1) b.hour ul li').length

    for i in 1..hourRowCount
      element = getElement(:css, "#time-picker div:nth-of-type(1) b.hour ul li:nth-of-type(" + i.to_s + ") button")
      className = element.attribute("class")

      if className.include?('selected') == true then
        return getTextForElement(:css, "#time-picker div:nth-of-type(1) b.hour ul li:nth-of-type(" + i.to_s + ") button")
        break
      end

    end
  end

  def getTime()
    return getTextFromInput(:css, "input[name='time']")
  end

  def getTimePerEntry(i)
    return getTextFromInput(:css, "input[name='time_#{i.to_s}']")
  end

  def setTimeFromGUI(hour, minStr, period)
    setHour(hour)
    sleep 1
    setMinute(minStr)
    sleep 1
    setAMPM(period)
    sleep 1

    clickSet()
    sleep 1
  end

  def isTimeDisplayedCorrectly(timeStr)

    displayedCorrectly = true
    displayedTimeStr = getTextFromInput(:css, "input[name='time_0']")

    if displayedTimeStr != timeStr then
      displayedCorrectly = false
    end

    return displayedCorrectly
  end

end